//#include "ext.h"
//#include "z_dsp.h"
#include "m_pd.h"
#include <math.h>

/*******************************************************************/
/*  LP multiouts objet dynamiquement modifiable nombre de sorties  */
/*                janvier 2003 - GMEM                              */
/*******************************************************************/
static t_class *multiouts_class;

typedef struct _multiouts_tilde
{
    t_object x_obj;
	float x_scal;		// distance de la source entre le centre (0.) et les HP (1.)
	float x_teta;		// angle entre 0. et 1.****
	
	float x_hp1scp; 	// vol de chaque HP avec correction de distance (prev)
	float x_hp2scp;
	float x_hp3scp;
	float x_hp4scp;
	float x_hp5scp;
	float x_hp6scp;
	float x_hp7scp;
	float x_hp8scp;
	float x_hp9scp;
	float x_hp10scp;
	float x_hp11scp;
	float x_hp12scp;
	float x_hp13scp;
	float x_hp14scp;
	float x_hp15scp;
	float x_hp16scp;

	float x_hp1scn; 	// vol de chaque HP avec correction de distance (next)
	float x_hp2scn;
	float x_hp3scn;
	float x_hp4scn;
	float x_hp5scn;
	float x_hp6scn;
	float x_hp7scn;
	float x_hp8scn;
	float x_hp9scn;
	float x_hp10scn;
	float x_hp11scn;
	float x_hp12scn;
	float x_hp13scn;
	float x_hp14scn;
	float x_hp15scn;
	float x_hp16scn;

	float x_x1; 			// (hpi-next - hpi-prev) / nsamp = distance  parcourir
	float x_x2;
	float x_x3;
	float x_x4;
	float x_x5;
	float x_x6;
	float x_x7;
	float x_x8;
	float x_x9;
	float x_x10;
	float x_x11;
	float x_x12;
	float x_x13;
	float x_x14;
	float x_x15;
	float x_x16;

    long  x_sr;	
    long  x_position;	/* position entre nsamp et < 0 */
    int  x_nsamp;		/* number of samples during each line sr/f */
    int  x_nouts;		/* number of outputs */

	float x_f;
} t_multiouts_tilde;

float spat (float x, float d, int n);
float spat2 (float x, float d);
void *multiouts_new(float val);
t_int *multiouts_perform2(t_int *w);
t_int *multiouts_perform3(t_int *w);
t_int *multiouts_perform4(t_int *w);
t_int *multiouts_perform5(t_int *w);
t_int *multiouts_perform6(t_int *w);
t_int *multiouts_perform7(t_int *w);
t_int *multiouts_perform8(t_int *w);
t_int *multiouts_perform9(t_int *w);
t_int *multiouts_perform10(t_int *w);
t_int *multiouts_perform11(t_int *w);
t_int *multiouts_perform12(t_int *w);
t_int *multiouts_perform13(t_int *w);
t_int *multiouts_perform14(t_int *w);
t_int *multiouts_perform15(t_int *w);
t_int *multiouts_perform16(t_int *w);
void multiouts_floatval(t_multiouts_tilde *x, float f);
void multiouts_floatval2(t_multiouts_tilde *x);
void multiouts_floatval3(t_multiouts_tilde *x);
void multiouts_floatval4(t_multiouts_tilde *x);
void multiouts_floatval5(t_multiouts_tilde *x);
void multiouts_floatval6(t_multiouts_tilde *x);
void multiouts_floatval7(t_multiouts_tilde *x);
void multiouts_floatval8(t_multiouts_tilde *x);
void multiouts_floatval9(t_multiouts_tilde *x);
void multiouts_floatval10(t_multiouts_tilde *x);
void multiouts_floatval11(t_multiouts_tilde *x);
void multiouts_floatval12(t_multiouts_tilde *x);
void multiouts_floatval13(t_multiouts_tilde *x);
void multiouts_floatval14(t_multiouts_tilde *x);
void multiouts_floatval15(t_multiouts_tilde *x);
void multiouts_floatval16(t_multiouts_tilde *x);
void multiouts_floatdist(t_multiouts_tilde *x, float f);
void multiouts_intline(t_multiouts_tilde *x, float n);
void multiouts_dsp(t_multiouts_tilde *x, t_signal **sp, short *count);
void multiouts_dsp2(t_multiouts_tilde *x, t_signal **sp, short *count);
void multiouts_dsp3(t_multiouts_tilde *x, t_signal **sp, short *count);

void multiouts_tilde_setup(void)
{
    multiouts_class = class_new(gensym("multiouts~"), (t_newmethod)multiouts_new, CLASS_DEFAULT, (short)sizeof(t_multiouts_tilde), 0, A_DEFFLOAT, 0);
    class_addmethod(multiouts_class, (t_method)multiouts_floatval, gensym("val"), A_DEFFLOAT, 0);
    class_addmethod(multiouts_class, (t_method)multiouts_floatdist, gensym("dist"), A_DEFFLOAT, 0);
    class_addmethod(multiouts_class, (t_method)multiouts_intline, gensym("line"), A_DEFFLOAT, 0);
	CLASS_MAINSIGNALIN(multiouts_class, t_multiouts_tilde, x_f);
    class_addmethod(multiouts_class, (t_method)multiouts_dsp, gensym("dsp"), A_CANT, 0);
	class_sethelpsymbol(multiouts_class, gensym("multiouts~"));
	post("multiouts~ GMEM Marseille France - Laurent Pottier");
}

void *multiouts_new(float val)
{
    t_multiouts_tilde *x = (t_multiouts_tilde *)pd_new(multiouts_class);

  	inlet_new(&x->x_obj, &x->x_obj.ob_pd, gensym("float"), gensym("val"));
  	inlet_new(&x->x_obj, &x->x_obj.ob_pd, gensym("float"), gensym("dist"));
  	inlet_new(&x->x_obj, &x->x_obj.ob_pd, gensym("float"), gensym("line"));
   	
   	val = (val < 2 ? 1 : val) ;
   	val = (val > 16 ? 16 : val) ;
   	
   	x->x_nouts = val;

	outlet_new(&x->x_obj, &s_signal);
	outlet_new(&x->x_obj, &s_signal);
    
    if (val > 2)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 3)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 4)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 5)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 6)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 7)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 8)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 9)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 10)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 11)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 12)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 13)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 14)
		outlet_new(&x->x_obj, &s_signal);
    if (val > 15)
		outlet_new(&x->x_obj, &s_signal);

    x->x_sr = sys_getsr() ;
    
	x->x_x1 = 0. ;	
	x->x_x2 = 0. ;	
	x->x_x3 = 0. ;	
	x->x_x4 = 0. ;	
	x->x_x5 = 0. ;	
	x->x_x6 = 0. ;	
	x->x_x7 = 0. ;	
	x->x_x8 = 0. ;	
	x->x_x9 = 0. ;	
	x->x_x10 = 0. ;	
	x->x_x11 = 0. ;	
	x->x_x12 = 0. ;	
	x->x_x13 = 0. ;	
	x->x_x14 = 0. ;	
	x->x_x15 = 0. ;	
	x->x_x16 = 0. ;	

	x->x_hp1scp	= 1. ;	
	x->x_hp2scp	= 0. ;	
	x->x_hp3scp	= 0. ;	
	x->x_hp4scp	= 0. ;	
	x->x_hp5scp	= 0. ;	
	x->x_hp6scp	= 0. ;	
	x->x_hp7scp	= 0. ;	
	x->x_hp8scp	= 0. ;	
	x->x_hp9scp	= 0. ;	
	x->x_hp10scp = 0. ;	
	x->x_hp11scp = 0. ;	
	x->x_hp12scp = 0. ;	
	x->x_hp13scp = 0. ;	
	x->x_hp14scp = 0. ;	
	x->x_hp15scp = 0. ;	
	x->x_hp16scp = 0. ;	

	x->x_hp1scn	= 0. ;	
	x->x_hp2scn	= 0. ;	
	x->x_hp3scn	= 0. ;	
	x->x_hp4scn	= 0. ;	
	x->x_hp5scn	= 0. ;	
	x->x_hp6scn	= 0. ;	
	x->x_hp7scn	= 0. ;	
	x->x_hp8scn	= 0. ;	
	x->x_hp9scn	= 0. ;	
	x->x_hp10scn = 0. ;	
	x->x_hp11scn = 0. ;	
	x->x_hp12scn = 0. ;	
	x->x_hp13scn = 0. ;	
	x->x_hp14scn = 0. ;	
	x->x_hp15scn = 0. ;	
	x->x_hp16scn = 0. ;	


    x->x_nsamp 	= (t_int)(x->x_sr*0.05) ;       // 50 msec par defaut
	x->x_position =  x->x_nsamp ;
	x->x_scal = 1. ;
    x->x_teta = 0. ;
     
    return (x);
}

/*****************************************/
void multiouts_intline(t_multiouts_tilde *x, float n)
{
	x->x_nsamp 	= (t_int)(x->x_sr*n/1000) ;       
}
	
/*****************************************/
float spat2 (float x, float d)
{
	float x1;
	
	x1 = fmod(x, 1.0) ;
	x1 = (x1 < 0.5 ? 0.5 - x1 : x1 - 0.5) ; // x1 = abs(x - 0.5) ;
	x1 = (1 - (x1 * 2 * d)) ; 				// fct linaire ;
	x1 = (x1 < 0 ? 0 : x1) ; 				//  max(0, (1 - (x1 * 2)) ;
	// return pow(x1 , 0.5) * ((d / 2) + 0.5) ;// (racine de x1) compense pour la distance; ? ou
	return pow(x1 * ((d / 2) + 0.5) , 0.5)  ; //   racine de (x1 compens pour la distance) ?
}

float spat (float x, float d, int n)
{
	float x1;
	
	x1 = fmod(x, 1.0) ;
	x1 = (x1 < 0.5 ? 0.5 - x1 : x1 - 0.5) ; // x1 = abs(x - 0.5) ;
	x1 = (1 - (x1 * n * d)) ; // fct linaire ;
	x1 = (x1 < 0 ? 0 : x1) ; //  max(0, (1 - (x1 * 3)) ;
	return pow(x1 , 0.5) * ((d / 2) + 0.5) ; // (racine de x1) compense pour la distance;
}

/***************************************/
void multiouts_floatval(t_multiouts_tilde *x, float teta)
{
	teta = (teta < 0 ? 0 : teta) ;
	x->x_teta = teta ;

	switch (x->x_nouts) {	
		case 2: multiouts_floatval2 (x) ;
			break ;
		case 3: multiouts_floatval3 (x) ;
			break ;
		case 4: multiouts_floatval4 (x) ;
			break ;
		case 5: multiouts_floatval5 (x) ;
			break ;
		case 6: multiouts_floatval6 (x) ;
			break ;
		case 7: multiouts_floatval7 (x) ;
			break ;
		case 8: multiouts_floatval8 (x) ;
			break ;
		case 9: multiouts_floatval9 (x) ;
			break ;
		case 10: multiouts_floatval10 (x) ;
			break ;
		case 11: multiouts_floatval11 (x) ;
			break ;
		case 12: multiouts_floatval12 (x) ;
			break ;
		case 13: multiouts_floatval13 (x) ;
			break ;
		case 14: multiouts_floatval14 (x) ;
			break ;
		case 15: multiouts_floatval15 (x) ;
			break ;
		case 16: multiouts_floatval16 (x) ;
	}
	x->x_x1 = (x->x_hp1scn - x->x_hp1scp) / (x->x_nsamp + 1) ;
	x->x_x2 = (x->x_hp2scn - x->x_hp2scp) / (x->x_nsamp + 1) ;
	x->x_x3 = (x->x_hp3scn - x->x_hp3scp) / (x->x_nsamp + 1) ;
	x->x_x4 = (x->x_hp4scn - x->x_hp4scp) / (x->x_nsamp + 1) ;
	x->x_x5 = (x->x_hp5scn - x->x_hp5scp) / (x->x_nsamp + 1) ;
	x->x_x6 = (x->x_hp6scn - x->x_hp6scp) / (x->x_nsamp + 1) ;
	x->x_x7 = (x->x_hp7scn - x->x_hp7scp) / (x->x_nsamp + 1) ;
	x->x_x8 = (x->x_hp8scn - x->x_hp8scp) / (x->x_nsamp + 1) ;
	x->x_x9 = (x->x_hp9scn - x->x_hp9scp) / (x->x_nsamp + 1) ;
	x->x_x10 = (x->x_hp10scn - x->x_hp10scp) / (x->x_nsamp + 1) ;
	x->x_x11 = (x->x_hp11scn - x->x_hp11scp) / (x->x_nsamp + 1) ;
	x->x_x12 = (x->x_hp12scn - x->x_hp12scp) / (x->x_nsamp + 1) ;
	x->x_x13 = (x->x_hp13scn - x->x_hp13scp) / (x->x_nsamp + 1) ;
	x->x_x14 = (x->x_hp14scn - x->x_hp14scp) / (x->x_nsamp + 1) ;
	x->x_x15 = (x->x_hp15scn - x->x_hp15scp) / (x->x_nsamp + 1) ;
	x->x_x16 = (x->x_hp16scn - x->x_hp16scp) / (x->x_nsamp + 1) ;
	x->x_position =  x->x_nsamp ;
}

void multiouts_floatval2(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	x->x_hp1scn = spat2( teta + 0.5, d) ;	
	x->x_hp2scn = spat2( teta + 0.0, d) ;	
}
void multiouts_floatval3(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval4(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval5(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval6(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval7(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval8(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval9(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (1 * delta), d, n) ;		
}
void multiouts_floatval10(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval11(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multiouts_floatval12(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp12scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multiouts_floatval13(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp12scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp13scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multiouts_floatval14(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp12scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp13scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp14scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}


void multiouts_floatval15(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 + (7 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp12scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp13scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp14scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp15scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multiouts_floatval16(t_multiouts_tilde *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp1scn = spat( teta + 0.5, d, n) ;	
	x->x_hp2scn = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp3scn = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp4scn = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp5scn = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp6scn = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp7scn = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp8scn = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp9scn = spat( teta + 0.5 - (8 * delta), d, n) ;	
	x->x_hp10scn = spat( teta + 0.5 + (7 * delta), d, n) ;	
	x->x_hp11scn = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp12scn = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp13scn = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp14scn = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp15scn = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp16scn = spat( teta + 0.5 + (1 * delta), d, n) ;	
}



/***************************************/
void multiouts_floatdist(t_multiouts_tilde *x, float d)
{
	d = (d > 1. ? 1. : d) ;
	d = (d < 0. ? 0. : d) ;

	x->x_scal = d ;

	switch (x->x_nouts) {	
		case 2: multiouts_floatval2 (x) ;
			break ;
		case 3: multiouts_floatval3 (x) ;
			break ;
		case 4: multiouts_floatval4 (x) ;
			break ;
		case 5: multiouts_floatval5 (x) ;
			break ;
		case 6: multiouts_floatval6 (x) ;
			break ;
		case 7: multiouts_floatval7 (x) ;
			break ;
		case 8: multiouts_floatval8 (x) ;
			break ;
		case 9: multiouts_floatval9 (x) ;
			break ;
		case 10: multiouts_floatval10 (x) ;
			break ;
		case 11: multiouts_floatval11 (x) ;
			break ;
		case 12: multiouts_floatval12 (x) ;
			break ;
		case 13: multiouts_floatval13 (x) ;
			break ;
		case 14: multiouts_floatval14 (x) ;
			break ;
		case 15: multiouts_floatval15 (x) ;
			break ;
		case 16: multiouts_floatval16 (x) ;
	}
	x->x_x1 = (x->x_hp1scn - x->x_hp1scp) / (x->x_nsamp + 1) ;
	x->x_x2 = (x->x_hp2scn - x->x_hp2scp) / (x->x_nsamp + 1) ;
	x->x_x3 = (x->x_hp3scn - x->x_hp3scp) / (x->x_nsamp + 1) ;
	x->x_x4 = (x->x_hp4scn - x->x_hp4scp) / (x->x_nsamp + 1) ;
	x->x_x5 = (x->x_hp5scn - x->x_hp5scp) / (x->x_nsamp + 1) ;
	x->x_x6 = (x->x_hp6scn - x->x_hp6scp) / (x->x_nsamp + 1) ;
	x->x_x7 = (x->x_hp7scn - x->x_hp7scp) / (x->x_nsamp + 1) ;
	x->x_x8 = (x->x_hp8scn - x->x_hp8scp) / (x->x_nsamp + 1) ;
	x->x_x9 = (x->x_hp9scn - x->x_hp9scp) / (x->x_nsamp + 1) ;
	x->x_x10 = (x->x_hp10scn - x->x_hp10scp) / (x->x_nsamp + 1) ;
	x->x_x11 = (x->x_hp11scn - x->x_hp11scp) / (x->x_nsamp + 1) ;
	x->x_x12 = (x->x_hp12scn - x->x_hp12scp) / (x->x_nsamp + 1) ;
	x->x_x13 = (x->x_hp13scn - x->x_hp13scp) / (x->x_nsamp + 1) ;
	x->x_x14 = (x->x_hp14scn - x->x_hp14scp) / (x->x_nsamp + 1) ;
	x->x_x15 = (x->x_hp15scn - x->x_hp15scp) / (x->x_nsamp + 1) ;
	x->x_x16 = (x->x_hp16scn - x->x_hp16scp) / (x->x_nsamp + 1) ;
	x->x_position =  x->x_nsamp ;
}

/**********************************************************/
/* 0 = entree gauche, 1 = control de pan, ensuite sorties */
void multiouts_dsp(t_multiouts_tilde *x, t_signal **sp, short *count)
{
	int n = x->x_nouts ;

	switch (n) 
	{
		case 2 :
			dsp_add(multiouts_perform2, 5, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,    						/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 3 :
			dsp_add(multiouts_perform3, 6, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 4 :
			dsp_add(multiouts_perform4, 7, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec,
			 		sp[0]->s_n+1);
			break ;
		case 5 :
			dsp_add(multiouts_perform5, 8, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec, 
			 		sp[0]->s_n+1);
			break ;
		case 6 :
			dsp_add(multiouts_perform6, 9, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 7 :
			dsp_add(multiouts_perform7, 10, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, 
			 		sp[0]->s_n+1);
			break ;
		case 8 :
			dsp_add(multiouts_perform8, 11, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,
			 		sp[0]->s_n+1);
			break ;
		case 9 :
			dsp_add(multiouts_perform9, 12, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 10 :
			dsp_add(multiouts_perform10, 13, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec,
			 		sp[0]->s_n+1);
			break ;
		case 11 :
			dsp_add(multiouts_perform11, 14, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec, 
			 		sp[0]->s_n+1);
			break ;
		case 12 :
			dsp_add(multiouts_perform12, 15, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec,  sp[12]->s_vec,    		/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 13 :
			dsp_add(multiouts_perform13, 16, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec,  sp[12]->s_vec,    		/* outputs */
			 		sp[13]->s_vec, 
			 		sp[0]->s_n+1);
			break ;
		case 14 :
			dsp_add(multiouts_perform14, 17, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec,  sp[12]->s_vec,    		/* outputs */
			 		sp[13]->s_vec, sp[14]->s_vec,  
			 		sp[0]->s_n+1);
			break ;
		case 15 :
			dsp_add(multiouts_perform15, 18, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec,  sp[12]->s_vec,    		/* outputs */
			 		sp[13]->s_vec, sp[14]->s_vec,  sp[15]->s_vec,    		/* outputs */
			 		sp[0]->s_n+1);
			break ;
		case 16 :
			dsp_add(multiouts_perform16, 19, x, sp[0]->s_vec , 			/* inputs */
			 		sp[1]->s_vec, sp[2]->s_vec,  sp[3]->s_vec,    		/* outputs */
			 		sp[4]->s_vec, sp[5]->s_vec,  sp[6]->s_vec,    		/* outputs */
			 		sp[7]->s_vec, sp[8]->s_vec,  sp[9]->s_vec,    		/* outputs */
			 		sp[10]->s_vec, sp[11]->s_vec,  sp[12]->s_vec,    		/* outputs */
			 		sp[13]->s_vec, sp[14]->s_vec,  sp[15]->s_vec,    		/* outputs */
			 		sp[16]->s_vec, 
			 		sp[0]->s_n+1);
			break ;

	}
}


/***************************************************************/
/****************** PERFORMS METHODS ***************************/
/***************************************************************/

t_int *multiouts_perform2(t_int *w)
{
	float val1, val2;
	float valf1, valf2;
	float x1, x2;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	
	n = (int)(w[5]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
   		 	val1 = valf1 ;
   		 	val2 = valf2 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
  			x1 = 0. ;
   			x2 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	
	x->x_position = position ;
	
	return (w+6);
}
	
t_int *multiouts_perform3(t_int *w)
{
	float val1, val2, val3;
	float valf1, valf2, valf3;
	float x1, x2, x3;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	n = (int)(w[6]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
   		 	val1 = valf1 ;
   		 	val2 = valf2 ;
   		 	val3 = valf3 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	
	x->x_position = position ;
	
	return (w+7);
}
	
t_int *multiouts_perform4(t_int *w)
{
	float val1, val2, val3, val4;
	float valf1, valf2, valf3, valf4;
	float x1, x2, x3, x4;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	
	n = (int)(w[7]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;


	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	
	x->x_position = position ;
	
	return (w+8);
}
	
t_int *multiouts_perform5(t_int *w)
{
	float val1, val2, val3, val4, val5;
	float valf1, valf2, valf3, valf4, valf5;
	float x1, x2, x3, x4, x5;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	
	n = (int)(w[8]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	
	x->x_position = position ;
	
	return (w+9);
}
	
t_int *multiouts_perform6(t_int *w)
{
	float val1, val2, val3, val4, val5, val6;
	float valf1, valf2, valf3, valf4, valf5, valf6;
	float x1, x2, x3, x4, x5, x6;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	
	n = (int)(w[9]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	
	x->x_position = position ;
	
	return (w+10);
}
	
t_int *multiouts_perform7(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7;
	float x1, x2, x3, x4, x5, x6, x7;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	
	n = (int)(w[10]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	
	x->x_position = position ;
	
	return (w+11);
}
	
t_int *multiouts_perform8(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	
	n = (int)(w[11]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	
	x->x_position = position ;
	
	return (w+12);
}
	
t_int *multiouts_perform9(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	
	n = (int)(w[12]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	
	x->x_position = position ;
	
	return (w+13);
}
	
t_int *multiouts_perform10(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	
	n = (int)(w[13]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	
	x->x_position = position ;
	
	return (w+14);
}
	
t_int *multiouts_perform11(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	
	n = (int)(w[14]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
		
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	
	x->x_position = position ;
	
	return (w+15);
}
	
t_int *multiouts_perform12(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11, val12;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11, valf12 ;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11, x12;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	float *out12 = (float *)(w[14]);
	
	n = (int)(w[15]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;
	val12  = x->x_hp12scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
	valf12  = x->x_hp12scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;
	x12 = x->x_x12 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
     		val12 = val12 + x12;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
			val12 = valf12 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   			x12 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	x->x_hp12scp = val12 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	x->x_x12 = x12 ;
	
	x->x_position = position ;
	
	return (w+16);
}
	
t_int *multiouts_perform13(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11, val12, val13;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11, valf12, valf13;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11, x12, x13;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	float *out12 = (float *)(w[14]);
	float *out13 = (float *)(w[15]);
	
	n = (int)(w[16]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;
	val12  = x->x_hp12scp ;
	val13  = x->x_hp13scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
	valf12  = x->x_hp12scn ;
	valf13  = x->x_hp13scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;
	x12 = x->x_x12 ;
	x13 = x->x_x13 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
     		val12 = val12 + x12;
     		val13 = val13 + x13;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
			val12 = valf12 ;
			val13 = valf13 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   			x12 = 0. ;
   			x13 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	x->x_hp12scp = val12 ;
	x->x_hp13scp = val13 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	x->x_x12 = x12 ;
	x->x_x13 = x13 ;
	
	x->x_position = position ;
	
	return (w+17);
}
	
t_int *multiouts_perform14(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11, val12, val13, val14;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11, valf12, valf13, valf14;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11, x12, x13, x14;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	float *out12 = (float *)(w[14]);
	float *out13 = (float *)(w[15]);
	float *out14 = (float *)(w[16]);
	
	n = (int)(w[17]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;
	val12  = x->x_hp12scp ;
	val13  = x->x_hp13scp ;
	val14  = x->x_hp14scp ;

	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
	valf12  = x->x_hp12scn ;
	valf13  = x->x_hp13scn ;
	valf14  = x->x_hp14scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;
	x12 = x->x_x12 ;
	x13 = x->x_x13 ;
	x14 = x->x_x14 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
     		val12 = val12 + x12;
     		val13 = val13 + x13;
     		val14 = val14 + x14;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
			val12 = valf12 ;
			val13 = valf13 ;
			val14 = valf14 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   			x12 = 0. ;
   			x13 = 0. ;
   			x14 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	x->x_hp12scp = val12 ;
	x->x_hp13scp = val13 ;
	x->x_hp14scp = val14 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	x->x_x12 = x12 ;
	x->x_x13 = x13 ;
	x->x_x14 = x14 ;
	
	x->x_position = position ;
	
	return (w+18);
}
	
t_int *multiouts_perform15(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11, val12, val13, val14, val15;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11, valf12, valf13, valf14, valf15;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11, x12, x13, x14, x15;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	float *out12 = (float *)(w[14]);
	float *out13 = (float *)(w[15]);
	float *out14 = (float *)(w[16]);
	float *out15 = (float *)(w[17]);
	
	n = (int)(w[18]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;
	val12  = x->x_hp12scp ;
	val13  = x->x_hp13scp ;
	val14  = x->x_hp14scp ;
	val15  = x->x_hp15scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
	valf12  = x->x_hp12scn ;
	valf13  = x->x_hp13scn ;
	valf14  = x->x_hp14scn ;
	valf15  = x->x_hp15scn ;
	
	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;
	x12 = x->x_x12 ;
	x13 = x->x_x13 ;
	x14 = x->x_x14 ;
	x15 = x->x_x15 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
     		val12 = val12 + x12;
     		val13 = val13 + x13;
     		val14 = val14 + x14;
     		val15 = val15 + x15;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
   			*out15++ = insig * val15;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
			val12 = valf12 ;
			val13 = valf13 ;
			val14 = valf14 ;
			val15 = valf15 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
   			*out15++ = insig * val15;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   			x12 = 0. ;
   			x13 = 0. ;
   			x14 = 0. ;
   			x15 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	x->x_hp12scp = val12 ;
	x->x_hp13scp = val13 ;
	x->x_hp14scp = val14 ;
	x->x_hp15scp = val15 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	x->x_x12 = x12 ;
	x->x_x13 = x13 ;
	x->x_x14 = x14 ;
	x->x_x15 = x15 ;
	
	x->x_position = position ;
	
	return (w+19);
}
	
t_int *multiouts_perform16(t_int *w)
{
	float val1, val2, val3, val4, val5, val6, val7, val8;
	float val9, val10, val11, val12, val13, val14, val15, val16;
	float valf1, valf2, valf3, valf4, valf5, valf6, valf7, valf8;
	float valf9, valf10, valf11, valf12, valf13, valf14, valf15, valf16;
	float x1, x2, x3, x4, x5, x6, x7, x8;
	float x9, x10, x11, x12, x13, x14, x15, x16;
	float scal, scalA, scalB, insig ;
	int n ;
	long position ;

  	t_multiouts_tilde *x = (t_multiouts_tilde *)(w[1]);
  
  	float *in =   (float *)(w[2]);
	float *out1 = (float *)(w[3]);
	float *out2 = (float *)(w[4]);
	float *out3 = (float *)(w[5]);
	float *out4 = (float *)(w[6]);
	float *out5 = (float *)(w[7]);
	float *out6 = (float *)(w[8]);
	float *out7 = (float *)(w[9]);
	float *out8 = (float *)(w[10]);
	float *out9 = (float *)(w[11]);
	float *out10 = (float *)(w[12]);
	float *out11 = (float *)(w[13]);
	float *out12 = (float *)(w[14]);
	float *out13 = (float *)(w[15]);
	float *out14 = (float *)(w[16]);
	float *out15 = (float *)(w[17]);
	float *out16 = (float *)(w[18]);
	
	n = (int)(w[19]);
	
	position = x->x_position ;
			
	val1  = x->x_hp1scp ;
	val2  = x->x_hp2scp ;
	val3  = x->x_hp3scp ;
	val4  = x->x_hp4scp ;
	val5  = x->x_hp5scp ;
	val6  = x->x_hp6scp ;
	val7  = x->x_hp7scp ;
	val8  = x->x_hp8scp ;
	val9  = x->x_hp9scp ;
	val10  = x->x_hp10scp ;
	val11  = x->x_hp11scp ;
	val12  = x->x_hp12scp ;
	val13  = x->x_hp13scp ;
	val14  = x->x_hp14scp ;
	val15  = x->x_hp15scp ;
	val16  = x->x_hp16scp ;
	
	valf1  = x->x_hp1scn ;
	valf2  = x->x_hp2scn ;
	valf3  = x->x_hp3scn ;
	valf4  = x->x_hp4scn ;
	valf5  = x->x_hp5scn ;
	valf6  = x->x_hp6scn ;
	valf7  = x->x_hp7scn ;
	valf8  = x->x_hp8scn ;
	valf9  = x->x_hp9scn ;
	valf10  = x->x_hp10scn ;
	valf11  = x->x_hp11scn ;
	valf12  = x->x_hp12scn ;
	valf13  = x->x_hp13scn ;
	valf14  = x->x_hp14scn ;
	valf15  = x->x_hp15scn ;
	valf16  = x->x_hp16scn ;

	x1 = x->x_x1 ;
	x2 = x->x_x2 ;
	x3 = x->x_x3 ;
	x4 = x->x_x4 ;
	x5 = x->x_x5 ;
	x6 = x->x_x6 ;
	x7 = x->x_x7 ;
	x8 = x->x_x8 ;
	x9 = x->x_x9 ;
	x10 = x->x_x10 ;
	x11 = x->x_x11 ;
	x12 = x->x_x12 ;
	x13 = x->x_x13 ;
	x14 = x->x_x14 ;
	x15 = x->x_x15 ;
	x16 = x->x_x16 ;

	while (--n) 
    { 
    	if(position--)   
    	{
     		insig = *in++ ;
     		val1 = val1 + x1;
     		val2 = val2 + x2;
     		val3 = val3 + x3;
     		val4 = val4 + x4;
     		val5 = val5 + x5;
     		val6 = val6 + x6;
     		val7 = val7 + x7;
     		val8 = val8 + x8;
     		val9 = val9 + x9;
     		val10 = val10 + x10;
     		val11 = val11 + x11;
     		val12 = val12 + x12;
     		val13 = val13 + x13;
     		val14 = val14 + x14;
     		val15 = val15 + x15;
     		val16 = val16 + x16;
    
       		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
   			*out15++ = insig * val15;
   			*out16++ = insig * val16;
   		}
   		else  			// si position arrive  zro
   		{
   		 	insig = *in++ ;
			val1 = valf1 ;
			val2 = valf2 ;
			val3 = valf3 ;
			val4 = valf4 ;
			val5 = valf5 ;
			val6 = valf6 ;
			val7 = valf7 ;
			val8 = valf8 ;
			val9 = valf9 ;
			val10 = valf10 ;
			val11 = valf11 ;
			val12 = valf12 ;
			val13 = valf13 ;
			val14 = valf14 ;
			val15 = valf15 ;
			val16 = valf16 ;
     		*out1++ = insig * val1;
   			*out2++ = insig * val2;
   			*out3++ = insig * val3;
   			*out4++ = insig * val4;
   			*out5++ = insig * val5;
   			*out6++ = insig * val6;
   			*out7++ = insig * val7;
   			*out8++ = insig * val8;
       		*out9++ = insig * val9;
   			*out10++ = insig * val10;
   			*out11++ = insig * val11;
   			*out12++ = insig * val12;
   			*out13++ = insig * val13;
   			*out14++ = insig * val14;
   			*out15++ = insig * val15;
   			*out16++ = insig * val16;
  			x1 = 0. ;
   			x2 = 0. ;
   			x3 = 0. ;
   			x4 = 0. ;
   			x5 = 0. ;
   			x6 = 0. ;
   			x7 = 0. ;
   			x8 = 0. ;
   			x9 = 0. ;
   			x10 = 0. ;
   			x11 = 0. ;
   			x12 = 0. ;
   			x13 = 0. ;
   			x14 = 0. ;
   			x15 = 0. ;
   			x16 = 0. ;
   		} 
	}
	
	x->x_hp1scp = val1 ;
	x->x_hp2scp = val2 ;
	x->x_hp3scp = val3 ;
	x->x_hp4scp = val4 ;
	x->x_hp5scp = val5 ;
	x->x_hp6scp = val6 ;
	x->x_hp7scp = val7 ;
	x->x_hp8scp = val8 ;
	x->x_hp9scp = val9 ;
	x->x_hp10scp = val10 ;
	x->x_hp11scp = val11 ;
	x->x_hp12scp = val12 ;
	x->x_hp13scp = val13 ;
	x->x_hp14scp = val14 ;
	x->x_hp15scp = val15 ;
	x->x_hp16scp = val16 ;
	
	x->x_x1 = x1 ;
	x->x_x2 = x2 ;
	x->x_x3 = x3 ;
	x->x_x4 = x4 ;
	x->x_x5 = x5 ;
	x->x_x6 = x6 ;
	x->x_x7 = x7 ;
	x->x_x8 = x8 ; 
	x->x_x9 = x9 ;
	x->x_x10 = x10 ;
	x->x_x11 = x11 ;
	x->x_x12 = x12 ;
	x->x_x13 = x13 ;
	x->x_x14 = x14 ;
	x->x_x15 = x15 ;
	x->x_x16 = x16 ; 
	
	x->x_position = position ;
	
	return (w+20);
}
	
